function FixupHotkeyText(button)
    local hotkey = getglobal(button:GetName().."HotKey");
    local text = hotkey:GetText();

    if type(text) == "string" then
        text = gsub(text, "SHIFT", "s");
        text = gsub(text, "CTRL", "c");
        hotkey:SetText(text);
    end
end

function ActionBarKeybinds_Initialize()
    local info = ChatTypeInfo["SYSTEM"];
    DEFAULT_CHAT_FRAME:AddMessage("ActionBarKeybinds enabled.", info.r, info.g, info.b, info.id);

    local oldUpdate = MultiActionBar_Update;
    MultiActionBar_Update = function()
        for i = 1,12 do
            local button = getglobal("MultiBarBottomLeftButton"..i);
            button.buttonType = "MULTIACTIONBAR1BUTTON";
            local hotkey = getglobal(button:GetName().."HotKey");
            local bindingString = GetBindingKey("MULTIACTIONBAR1BUTTON"..button:GetID());
            hotkey:SetText(bindingString);
            FixupHotkeyText(button);
            hotkey:Show();

            local button = getglobal("MultiBarBottomRightButton"..i);
            button.buttonType = "MULTIACTIONBAR2BUTTON";
            local hotkey = getglobal(button:GetName().."HotKey");
            local bindingString = GetBindingKey("MULTIACTIONBAR2BUTTON"..button:GetID());
            hotkey:SetText(bindingString);
            FixupHotkeyText(button);
            hotkey:Show();

            local button = getglobal("MultiBarRightButton"..i);
            button.buttonType = "MULTIACTIONBAR3BUTTON";
            local hotkey = getglobal(button:GetName().."HotKey");
            local bindingString = GetBindingKey("MULTIACTIONBAR3BUTTON"..button:GetID());
            hotkey:SetText(bindingString);
            FixupHotkeyText(button);
            hotkey:Show();

            local button = getglobal("MultiBarLeftButton"..i);
            button.buttonType = "MULTIACTIONBAR4BUTTON";
            local hotkey = getglobal(button:GetName().."HotKey");
            local bindingString = GetBindingKey("MULTIACTIONBAR4BUTTON"..button:GetID());
            hotkey:SetText(bindingString);
            FixupHotkeyText(button);
            hotkey:Show();
        end

        oldUpdate();
    end

    local oldActionButton_OnEvent = ActionButton_OnEvent;

    ActionButton_OnEvent = function(event)
        oldActionButton_OnEvent(event);

        if (event == "UPDATE_BINDINGS") then
           ActionButton_UpdateHotkeys(this.buttonType);
           FixupHotkeyText(this);
        end
    end
end